Subject: bug#20432: GDK_SCALE=2 GDK_DPI_SCALE=0.5 destroys GTK+ 3 scroll bar

From: Jan Djärv <[email-masked]>
Date: Thu, 14 May 2015 14:33:29 +0200

Den 2015-05-14 13:59, Felix E. Klee skrev:
> On Thu, May 14, 2015 at 12:34 PM, Jan Djärv <[email-masked]> wrote:
>> This GTK feature is very poorly designed.
>
> HiDPI scaling works beautifully in various other GTK+ 3 applications.

I'm sure it does, but the world is bigger than Gtk+ 3.

>
>> We can not support it correctly, as we don't use Gtk+ exclusively.
>
> Thanks for the explanation.
>
>> Also, the Gtk+ code blindly multiplies anything with GTK_SCALE. So for
>> example, given GTK_SCALE=2, if we have font size 15, it becomes 30.
>
> That is what `GDK_DPI_SCALE` is for. Example:
>
>      export GDK_SCALE=2
>      export GDK_DPI_SCALE=0.5

That does not help.  For WM hints, Gtk+ uses GDK_SCALE. GDK_DPI_SCALE is only 
used for scaling Xft fonts.  Anyway, multiplying with 0.5 or divide by 2 is 
the same for integer arithmetics.

An alternative would be for Emacs to multply font sizes with GDK_SCALE.
I think that might be tricky, but I will check.

>
>> So there will be glitches, live with it.
>
> It’s not for me. I set up a HiDPI machine for a friend who’s turning
> eighty this year. While he has great vision given his age, some UI
> elements are just too small without scaling. They are barely visible.
>
> This is a big issue, not something that should be ignored. Get access to
> a HiDPI screen, and you’ll see what I mean.

I have three already.

	Jan D.